/*************************************************************************
*** This is NeTAMS, version 4
***	(c) 1998-2002 Anton Vinokurov <anton@netams.com>
***	(c) 2002-2010 NeTAMS Development Team
***	All rights reserved. See 'Copying' file included in distribution
***	For latest version and more info, visit this project web page
***	located at http://www.netams.com
***
*************************************************************************/
/* $Id$ */

#include "config.h"
#include <sys/time.h>

#define MAX_REQUEST_SIZE 512

#ifdef WIN32
#include "mingw.h"

#endif

int main(int argc, char *argv[]){

	if (argc<2) {
		printf("argument must be specified\n");
		return 0;
	}

	int sockfd;
	struct sockaddr_in servaddr;
	int pktlen;
	char *sendbuffer=(char*)malloc(MAX_REQUEST_SIZE);
	struct pollfd x;

	// assemble full input string as space separated items from argv[]
	sendbuffer[0]='\0';
	for (int i=1; i<argc; i++) {
		int j = MAX_REQUEST_SIZE - strlen(sendbuffer) - strlen(argv[i])-2;
		strncat(sendbuffer, argv[i], j);
		strcat(sendbuffer, " ");
	}
	pktlen = strlen(sendbuffer);
	
	sockfd=socket(AF_INET,SOCK_DGRAM,0);
	memset(&servaddr, '\0', sizeof(servaddr));
	servaddr.sin_family = AF_INET;
	servaddr.sin_addr.s_addr=inet_addr("127.0.0.1");
	servaddr.sin_port=htons(20003);
	
	int j=sendto(sockfd,sendbuffer, pktlen, 0, (struct sockaddr *)&servaddr,sizeof(servaddr));

	x.fd = sockfd;
	x.events = POLLIN;

	j=poll(&x, 1, 3000);

	if (j==0) printf("TIMEOUT\n");
	else if (j<0) perror("poll: ");
	else {
		char buf[MAX_REQUEST_SIZE];
		struct sockaddr_in rcv_addr;
		bzero(buf, MAX_REQUEST_SIZE);
		socklen_t rcv_addr_len=sizeof(struct sockaddr_in);
		int len=recvfrom(sockfd,buf,MAX_REQUEST_SIZE,0,(struct sockaddr *)&rcv_addr,&rcv_addr_len);
		if (len>0) printf("%s\n", buf);
	}
	return 0;
}

